Codeforces Round #403 C. Underground Lab(脑洞)

185 篇文章 0 订阅
116 篇文章 0 订阅

The evil Bumbershoot corporation produces clones for gruesome experiments in a vast underground lab. On one occasion, the corp cloned a boy Andryusha who was smarter than his comrades. Immediately Andryusha understood that something fishy was going on there. He rallied fellow clones to go on a feud against the evil corp, and they set out to find an exit from the lab. The corp had to reduce to destroy the lab complex.

The lab can be pictured as a connected graph with n vertices and m edges. k clones of Andryusha start looking for an exit in some of the vertices. Each clone can traverse any edge once per second. Any number of clones are allowed to be at any vertex simultaneously. Each clone is allowed to stop looking at any time moment, but he must look at his starting vertex at least. The exit can be located at any vertex of the lab, hence each vertex must be visited by at least one clone.

Each clone can visit at most  vertices before the lab explodes.

Your task is to choose starting vertices and searching routes for the clones. Each route can have at most  vertices.

Input

The first line contains three integers nm, and k (1 ≤ n ≤ 2·105n - 1 ≤ m ≤ 2·1051 ≤ k ≤ n) — the number of vertices and edges in the lab, and the number of clones.

Each of the next m lines contains two integers xi and yi (1 ≤ xi, yi ≤ n) — indices of vertices connected by the respective edge. The graph is allowed to have self-loops and multiple edges.

The graph is guaranteed to be connected.

Output

You should print k lines. i-th of these lines must start with an integer ci () — the number of vertices visited by i-th clone, followed by ci integers — indices of vertices visited by this clone in the order of visiting. You have to print each vertex every time it is visited, regardless if it was visited earlier or not.

It is guaranteed that a valid answer exists.

Examples
input
3 2 1
2 1
3 1
output
3 2 1 3
input
5 4 2
1 2
1 3
1 4
1 5
output
3 2 1 3
3 4 1 5
Note

In the first sample case there is only one clone who may visit vertices in order (2, 1, 3), which fits the constraint of 6 vertices per clone.

In the second sample case the two clones can visited vertices in order (2, 1, 3) and (4, 1, 5), which fits the constraint of 5 vertices per clone.


题意:可以转化为让你用k条链(每条链最长2*n/k)来覆盖一棵树。


分析:一开始小看了2*n/k这个条件,yy了一个很繁琐的做法(从n个单点开始用set维护合并链),因为k * (2*n/k) >= 2*n,所以我们直接按dfs序划分就够了。。。


#include <bits/stdc++.h>
#define MOD 1000000007
#define N 200005
using namespace std;
int n,m,u,v,k,leng,num,vis[N];
vector<int> G[N],List[N];
void dfs(int u)
{
	vis[u] = true;
	if(List[num].size() < leng) List[num].push_back(u);
	else List[++num].push_back(u);	
	for(int v : G[u])
	 if(!vis[v])
	 {
	 	dfs(v);
	 	if(List[num].size() < leng) List[num].push_back(u);
		else List[++num].push_back(u);
	 } 
}
int main()
{
	scanf("%d%d%d",&n,&m,&k);
	for(int i = 1;i <= m;i++)
	{
		scanf("%d%d",&u,&v);
		G[u].push_back(v);
		G[v].push_back(u);	
	}	
	leng = ceil(2.0*n/k),num = 1;
	dfs(1);
	for(int i = 1;i <= k;i++)
	{
		if(List[i].size())
		{
			cout<<List[i].size()<<" ";
			for(int j = 0;j < List[i].size();j++) cout<<List[i][j]<<" ";
			cout<<endl;
		}
		else cout<<"1 1"<<endl;
	}
} 


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值